' (c) wellCAM CCS, LUBLIN
'
' Historia zmian:
' Data      Kto                  Co
' ========  ==================   ======================================
' 03.05.98  Romek Zaorski      	Pierwsza wersja
' 16.05.98  Romek Zaorski      	Dodano rozmieszcznia po prostej i dialog. Mozna rysowac otwor z gwintem po
'                                                       	napisaniu w polu srednicy M10 lub m10 . Uwaga przelaczanie opcji linia okrag - mysza albo <- lub ->
'                                                       	Jesli wypelni sie pole okrag srodkowy to przy rozmeiszczeniu po okregu narysuje sie otwor srodkowy
'                                                       	Ten sam efekt bedzie przy rozmieszczaniu w siatce 2x2
' 21.05.98  Romek Zaorski      	Potrafi juz rysowac fasolki. Zmiane orientacji
'                                				uzyskuje sie poprzez podanie dluzszej wartosci
'                                				jako pierwszej - kat 0, jako drugiej - kat 90
' 23.05.98  Romek Zaorski     		Dopisano procedury obrotu. Mozna teraz rysowac pod dowolnym katem
'                                				ale nie jest to jeszcze wykorzystywane
' 24.05.98  Romek Zaorski      	makro mozna wywolac z parametrami sterujacymi spospbem rozmieszczenia i rodzjem otworow
'                                				MacroRun "otworki.mcr","Gdzie:Co"
'                                				parametr Gdzie
'                                				0    'rozmieszczanie na okrego'
'                                				1    'rozmieszczanie po prostej
'                                				2    'rozmieszczanie w siatce
'                               			 	Parametr Co
'                                				0    'rysowanie otworow okraglych
'                                				1    'rysowanie otworow fasolkowym
'                                				2    'otwory prostokatne
'                                				3    'otwory kwadratowe
'
'27.05.98   Romek Zaorski     dodano funkcje NZ sprawdzajaca poprawnosc dancy wzgl. NULL i pustych
'                             			dodano funckje do dialogu.
'30.05.98   Romek Zaorski     zmieniono nazwy zmiennych , dodano nowe typy danych, poszerzono dzialanie
'                             			funkcji dialogu. dodano obrazki, dopisano zapiemtywanie ostatnich parametrow
'						dodano tryb serii pozawalajcy na umiesczanie serii pojedynczych otworow UWAGA zakonczenie serii ESC lub Cancel - tymczasem
'01.06.98	Romek Zaorski	dopisono shortkey do vDoX
'
Option Explicit                       		 		'obowiazkowa definicja zmiennych

Type P2P_Type			'definicja nowego typu zmiennej
   x As Double
   y As Double
End Type

'Type LIN_Type
'	Dwg As Object 	' gdzie rysowac
'	P1 As P2P_Type 	' poczatek
'	P2 As P2P_Type	' koniec
'	Typ As Integer	' rodzaj linii
'	Pla As Integer 	' Plaszczyzna
'End Type

Type Hole_Type		'definicja nowego typu zmiennej
    vDoX As Variant           'Srednica otworu
    vDoY As Variant           'uzywana do podania drugiego parametru otworu np fasolki
    vDrX As Variant              'Srednica rozmieszczenia
    vDrY As Variant              'Rozmieszczenia w osi Y
    vDs As Variant                'Srednica otworu srodkowego
    vCntX  As Variant            'Ilosc otwow w osi X lub na srednicy
    vCntY As Variant             'ilosc otworow w Osi Y
    vThr  As Boolean            'otwor gwintowany?
    vSerie  As Boolean         'seria otworow
    vOrd As P2P_Type         'offset osi X
    vHolTyp As Integer        'Typ otworu
    whrSet As Integer
End Type

Private Const CIRMOD As Integer = 0    	'rozmieszczanie na okrego
Private Const LINMOD As Integer = 1   	 'rozmieszczanie po prostej
Private Const GRDMOD As Integer = 2    	'rozmieszczanie w siatce
Private Const SERMOD As Integer = 3	' seria otworow
Private Const ROUHOL As Integer = 0    	'rysowanie otworow okraglych
Private Const OBLHOL As Integer = 1    	'rysowanie otworow fasolkowym
Private Const SQRHOL As Integer = 2    	'otwory prostokatne
Private Const RECHOL As Integer = 3    	'otwory kwadratowe
Private Const STD2PI As Double  = 6.28318530718
Private Const STDPI  As Double  = 3.14159265358979324


Dim Dat As Hole_Type
Dim Crr As P2P_Type             'oktualna pozycja ukladu w ktorym rysujemy element

' makro mozna wywolac z parametrami sterujacymi spospbem rozmieszczenia i rodzjem otworow
' MacroRun "otworki.mcr","Gdzie:Co"
' parametr Gdzie
' 0    'rozmieszczanie na okrego'
' 1    'rozmieszczanie po prostej
' 2    'rozmieszczanie w siatce
' Parametr Co
' 0    'rysowanie otworow okraglych
' 1    'rysowanie otworow fasolkowym
' 2    'otwory prostokatne
' 3    'otwory kwadratowe


Sub Main
Dim i As Integer

    If RunDlg(Command$) Then        ' uruchamia procedure pobierania danych
   'If RunDlg("2;0;20") Then        ' uruchamia procedure pobierania danych
        Dim doc As Object                                'Arkusz roboczy na ktory bedzie wstawiany otwor
        Set doc = Application.ActiveDocument             'Ustawienie  jako arkusz roboczy arkusz z aktywnego okna
        Dim dwg As Object                                'Definowanie obiektu dwg
        Set dwg = doc.Drawing                            'Przypisanie obiektu dwg jako rysunek arkusza roboczego
        Dim idx As Long

        idx = dwg.AddObject()                            'Stwrz nowy obiekt rysunkowy i zapamietaj jego indeks

         If (idx > 0) Then                               'Jesli udalo sie stworzyc obiekt rysunkowy
              dwg.OpenObject(idx)                        'Otwrz obiekt w celu dodania grafiki. Identyfikatorem jest tu idx
                   If DrawSymbol(dwg, 0,0, Dat.whrSet) Then  'Jesli narysowano cos. Jest to wywolanie funkcjii DrawSymbol z parametrem obiektu dwg i punktem wstawienia
                      dwg.SetPointORD(0,0)     'Punkt orientacyjny obiektu przesuniety o Dx i Dy
                      dwg.CloseObject()                       'Zamknij obiekt
                      WriteSettings
                      dwg.ExecuteString("SUW(mode=OSTOBI,p=[0,0])")   'Ustawia dynamicznie przesuwanie obiektu
                      'dwg.ExecuteString("KOP(mode=LSTCMP)")  'Kopiuje dynamicznie przesuwanie obiektu
                   Else
                      dwg.CloseObject()                       'Zamknij obiekt
                   End If
             End If
        End If
 End Sub

 Function RunDlg(ByVal ComLine As String) As Boolean
' funkcja pobiera dane z dialogu, sprawdza je a nastepnie podstawia dane
' w zaleznosci od Typu ustawia odpowiednie wartosci domyslne
' czesc danych jest podstawiana przez"referencje ByRef
 'ustawia rowniez gdzie nalezy roamieszczac whrSet

	Begin Dialog UserDialog 440,365,"Rozmieszczanie otworow",.DialogFunc ' %GRID:5,5,1,1
		Text 380,180,30,15,"O X",.Text5
		Text 380,210,30,15,"O Y",.Text4
		GroupBox 10,0,340,70,"Rodzaj rozmieszczenia",.GroupBox1
		Picture 20,30,50,35,MacroDir & "\Circle.bmp",0,.picCircle3
		Picture 185,30,50,35,MacroDir & "\Grid.bmp",0,.picGrid
		Picture 275,30,50,35,MacroDir & "\Serie.bmp",0,.picSerie
		Picture 30,305,50,35,MacroDir & "\Circle.bmp",0,.picCircle5
		OptionGroup .Roz
			OptionButton 20,15,80,15,"&Okrg"
			OptionButton 95,15,80,15,"&Prosta"
			OptionButton 180,15,70,15,"&Siatka"
			OptionButton 275,15,70,15,"S&eria"
		GroupBox 10,75,360,35,"Rodzaj otworu",.GroupBox2
		OptionGroup .What
			OptionButton 15,90,80,15,"O&krgy"
			OptionButton 100,90,80,15,"&Fasolka"
			OptionButton 185,90,80,15,"Kw&adrat"
			OptionButton 270,90,90,15,"P&rostokt"
		Text 15,125,100,40,"rednica o&tworu lub gwint np M10 ",.Text3
		TextBox 20,175,100,20,.txtDoX
		TextBox 20,205,100,20,.txtDoY
		Text 140,125,115,40,"rednica rozmieszczenia lub odstep",.Text1
		TextBox 145,175,100,20,.txtDrX
		TextBox 145,205,100,20,.txtDrY
		Text 300,150,40,15,"I&lo  ",.Text2
		TextBox 270,175,100,20,.txtCntX
		TextBox 270,205,100,20,.txtCntY
		GroupBox 10,240,420,115,"Dodatki",.AddBox
		Picture 30,305,50,35,MacroDir & "\midCir.bmp",0,.picMidCir
		Text 20,255,120,15,"Ot&wr rodkowy",.Text8
		TextBox 25,275,60,20,.txtDs
		Text 155,275,30,15,"d&X",.Text7
		TextBox 195,275,60,20,.txtOrdX
		Text 285,275,30,15,"d&Y",.Text6
		TextBox 330,275,60,20,.txtOrdY
		Text 165,255,240,15,"Przesuniecie punktu ORD obiektu",.Text9
		OKButton 370,30,60,20
		CancelButton 370,5,60,20
		Picture 380,80,40,30,MacroDir & "\oblong.bmp",0,.PicHol
		Picture 100,30,50,35,MacroDir & "\Line.bmp",0,.picLine
		Picture 255,300,70,40,MacroDir & "\dxdy.bmp",0,.picDxDy
		Text 235,315,15,15,"dy",.Text10
		Text 280,340,25,10,"dx",.Text11
	End Dialog

	Dim dlg As UserDialog
	Dim result As Integer
         Dim sString As String
         Dim ret As Boolean

    ReadSettings ' czytaj parametry

         dlg.Roz =  Val(Nz(fStrTok(ComLine,";"),Dat.whrSet))                  'domyslne ustawienie na linie
         dlg.What = Val(Nz(fStrTok(ComLine,";"),Dat.vHolTyp))   'domyslne ustawienie na linie
         dlg.txtDoX = Nz(fStrTok(ComLine,";"),CStr(Dat.vDoX))                                 'srednica otworu.
         dlg.txtDoY = Nz(fStrTok(ComLine,";"),CStr(Dat.vDoY))                                'odlegloszc rozmieszczenia na 0.
         dlg.txtDrX= Nz(fStrTok(ComLine,";"),CStr(Dat.vDrX))                'odlegloszc rozmieszczenia na 0.
         dlg.txtCntX = Nz(fStrTok(ComLine,";"),CStr(Dat.vCntX))                                    'pojedyncze otwory
         dlg.txtDrY = Nz(fStrTok(ComLine,";"),CStr(Dat.vDrY))                             'odlegloszc rozmieszczenia na 0.
         dlg.txtCntY= Nz(fStrTok(ComLine,";"),CStr(Dat.vCntY))                                    'pojedyncze otwory
         dlg.txtOrdX = Nz(fStrTok(ComLine,";"),CStr(Dat.vOrd.X) )                 'przesuniecie w osi X
         dlg.txtOrdY = Nz(fStrTok(ComLine,";"),CStr(Dat.vOrd.Y))                  'przesuniecie Y
         dlg.txtDs = Nz(fStrTok(ComLine,";"),CStr(Dat.vDs))                                        'srednica otworu srodkowego

   result = Dialog( dlg)                              'pokaz dialog

    If (-1 = result) Then                             'jesli nie wybrano cancel
       Call SetDia(dlg.txtDoX)                        ' sprawdz czy nie trzeba rysowac gwintu
       Dat.vDrX   =  CDbl( dlg.txtDrX)
       Dat.vDrY  =  CDbl( dlg.txtDrY)
       Dat.vDs   =  CDbl (dlg.txtDs)
       Dat.vDoY   =  CDbl (dlg.txtDoY)
       Dat.vCntX    =  Val(dlg.txtCntX)
       Dat.vCntY   =  Val(dlg.txtCntY)
       Dat.vOrd.X =  CDbl(dlg.txtOrdX)
       Dat.vOrd.Y =  CDbl(dlg.txtOrdY)
       Dat.whrSet = dlg.Roz                               'zmienna globalna gdzia nalezy roamieszczac
       Dat.vHolTyp = dlg.What

      ' Debug.Print "Dat.vDoX "; Dat.vDoX '    =  CDbl (dlg.txtDoY)
       'Debug.Print "Dat.vDoY ";  Dat.vDoY  ' ' =  CDbl (dlg.txtDoY)
      ' Debug.Print "Dat.vDrX ";  Dat.vDrX   ' '=  CDbl( dlg.txtDrX)
       'Debug.Print "Dat.vDrY ";  Dat.vDrY  '='=  CDbl( dlg.txtDrY)
       'Debug.Print "Dat.vDs  ";  Dat.vDs   '='=  CDbl (dlg.txtDs)
       'Debug.Print "Dat.vCntX "; Dat.vCntX'      =  Val(dlg.txtCntX)
       'Debug.Print "Dat.vCntY "; Dat.vCntY ' '  =  Val(dlg.txtCntY)
       'Debug.Print "Dat.vOrd.X ";Dat.vOrd.X ' '=  CDbl(dlg.txtOrdX)
       'Debug.Print "Dat.vOrd.Y ";Dat.vOrd.Y ' '=  CDbl(dlg.txtOrdY)
       'Debug.Print "Dat.whrSet ";Dat.whrSet ' '= dlg.Roz                               'zmienna globalna gdzia nalezy roamieszczac
       'Debug.Print "Dat.vHolTy ";Dat.vHolTyp'p' = dlg.What

       If GetDat(dlg.Roz) Then
           RunDlg = True                               'jesli podano wlasciwe dane
       Else
           RunDlg = False    'zle dane
       End If
    End If

End Function

Function DialogFunc%(DlgItem$, Action%, SuppValue%)

    Select Case Action%
     ' Dialog box initialization
     	Case 1
         		Beep
	         Select Case Dat.vHolTyp
	        		Case ROUHOL
	        			DlgEnable "txtDoY",False
	        			If Dat.vThr Then
	        				DlgSetPicture "PicHol", MacroDir & "\Thread.BMP",0
				Else
					DlgSetPicture "PicHol", MacroDir & "\Round.BMP",0
				End If
	        		Case SQRHOL
		        		DlgEnable "txtDoY",False
				DlgSetPicture "PicHol",MacroDir & "\Square.BMP",0
	        		Case RECHOL
	        			DlgSetPicture "PicHol",MacroDir & "\Rectan.BMP",0
	        		Case OBLHOL
	        			DlgSetPicture "PicHol",MacroDir & "\Oblong.BMP",0
	        	End Select
        		 Select Case Dat.whrSet
    			Case  CIRMOD     	'rozmieszczanie na okrego
			DlgEnable "txtDrX",True
			DlgEnable "txtDrY",False
			DlgEnable "txtCntY",False
			DlgEnable "txtDs",True
			DlgEnable "txtCntx",True
		Case  LINMOD    	 'rozmieszczanie po prostej
			DlgEnable "txtDrX",True
			DlgEnable "txtDrY",False
			DlgEnable "txtCntx",True
			DlgEnable "txtCntY",False
			DlgEnable "txtDs",False
		Case  GRDMOD    	'rozmieszczanie w siatce
			DlgEnable "txtDrY",True
			DlgEnable "txtDrX",True
			DlgEnable "txtCntX",True
			DlgEnable "txtCntY",True
			DlgEnable "txtDs",True
			'DlgText("txtCntY")=1
		Case  SERMOD 	' seria pojedynczych otworow 
			DlgEnable "txtDs",False
			DlgEnable "txtDrX",False
			DlgEnable "txtDrY",False
			DlgEnable "txtCntX",False
			DlgEnable "txtCntY",False
		End Select		
    Case 2 ' Value changing or button pressed
        	Select Case DlgItem$
               	Case "Roz"
               		Select Case SuppValue%
				Case  CIRMOD     	'rozmieszczanie na okrego
					DlgEnable "txtDrX",True
					DlgEnable "txtDrY",False
					DlgEnable "txtCntY",False
					DlgEnable "txtDs",True
					DlgEnable "txtCntx",True
				Case  LINMOD    	 'rozmieszczanie po prostej
					DlgEnable "txtDrX",True
					DlgEnable "txtDrY",False
					DlgEnable "txtCntx",True
					DlgEnable "txtCntY",False
					DlgEnable "txtDs",False
				Case  GRDMOD    	'rozmieszczanie w siatce
					DlgEnable "txtDrY",True
					DlgEnable "txtDrX",True
					DlgEnable "txtCntX",True
					DlgEnable "txtCntY",True
					DlgEnable "txtDs",True
					'DlgText("txtCntY")=1
				Case  SERMOD 	' seria otworow jeszce do zrobienia
					DlgEnable "txtDs",False
					DlgEnable "txtDrX",False
					DlgEnable "txtDrY",False
					DlgEnable "txtCntX",False
					DlgEnable "txtCntY",False
								End Select		
               		DialogFunc% = True 'do not exit the dialog
           	Case "What"
           		Select Case SuppValue%
           		 	Case ROUHOL
        					DlgEnable "txtDoY",False
					If Dat.vThr = True Then
        						DlgSetPicture "PicHol", MacroDir & "\Thread.BMP",0
					Else
						DlgSetPicture "PicHol",MacroDir & "\Round.BMP",0
					End If
        				Case SQRHOL
	        				DlgEnable "txtDoY",False
					DlgSetPicture "PicHol",MacroDir & "\Square.BMP",0
        				Case RECHOL
        					DlgEnable "txtDoY",True
        					DlgSetPicture "PicHol",MacroDir & "\Rectan.BMP",0
        				Case OBLHOL
        					DlgSetPicture "PicHol",MacroDir & "\Oblong.BMP",0
        					DlgEnable "txtDoY",True
			End Select
			DlgItem$ = "txtDoX"
               		DialogFunc% = True 'do not exit the dialog
	End Select

        Case 3 ' TextBox or ComboBox text changed
        Select Case DlgItem$
                  Case "txtCntX"
           		DialogFunc% = True 'do not exit the dialog
            	Case "txtDoX"
			' sprawdza czy nie ma gwintu
			'Debug.Print dlgval(dlgitem$)
			'Call SetDia(CStr(SuppValue%))                        ' sprawdz czy nie trzeba rysowac gwintu
			'If Dat.vThr Then
        			'	DlgSetPicture MacroDir & "\PicHole", "Thread.BMP",0
			'End If
           	'	DialogFunc% = True 'do not exit the dialog
		'Case "txtDs"
          	'	 DialogFunc% = True 'do not exit the dialog
      		'Case "txtDrX"
           		 DialogFunc% = True 'do not exit the dialog

           End Select
        Case 4 ' Focus changed
        		' pozwala na kor5zystanie z shortkey. Ustawia focus na teext wybrany
        		' skrotem a nastewpnie ustawia focus na okna ziazane z tym tekstem
		Select Case DlgItem$
                  Case "dX"
                  		'DlgItem$=  "txtOrdX"
                  		'DlgItem$ =  "txtDoX"
                  		'DialogFunc% = True 'do not exit the dialog
            	Case "dY"
	     		 'DlgItem$ =  "txtOrdY"
	     		 'DialogFunc% = True 'do not exit the dialog
	     	Case "Otwr rodkowy"
	     		'DlgItem$ =  "txtDs"
			'DialogFunc% = True 'do not exit the dialog
		Case "What"
			'DlgItem$ = "txtDoX" 'QQ nie wiem czego nie dziala
			'SuppValue% = 0
			'Debug.Print "dlg - ";DlgItem$
			'DialogFunc% = True 'do not exit the dialog
		Case "rednica otworu lub gwint np M10 "
			'DlgItem$ =  "txtDoX"
	     		'DialogFunc% = True 'do not exit the dialog
		End Select

        	Case 5 ' Idle DlgItem is a null string. SuppValue is zero
        	End Select

End Function

Function GetDat(ByVal roz As Integer) As Boolean
'sprawdzanie danych vDoX,Vdr,Vdn
   Dim bRet As Boolean
   bRet = False
   If Dat.vDoX> 0   Then
      If Dat.vDrX > 0   Or  (Dat.vCntX = 1 And roz <> CIRMOD) Then ' dla pojedynczych otworow Dr moze byc 0 ale nis moze to byc rozmieszczanie po okregu
         'If roz = LINMOD Or vDrX > 0 Then ' jesli nie jest rozieszczanie na okregu to dr moze byz zero jesli chcemy rysowac pojedynczy
           If  Dat.vCntX > 0 Then
               If (Dat.vHolTyp = ROUHOL ) Or Dat.vHolTyp =SQRHOL Or  (Dat.vHolTyp <> ROUHOL  And Dat.vDoY >0) Then ' vDoY musi byc wieksza od zera chyba, ze jest to okrag
                    bRet = True ' podano prawidlowe dane
               End If
           End If
         'End If
      End If
   End If
   GetDat = bRet
End Function


Function DrawSymbol(dwg As Object, ByVal x As Double, ByVal  y As Double ,ByVal  roz As Integer) As Boolean
   Dim bRet As Boolean 'wartosc zwracana przez funkcje. Falsz jesli przerwano lub blednie wprowadzono dane
   bRet = True ' na razie nie analizuje danych
   'x = x +vOrdX ' uwzglednia przesuniecie
   'y =y +vOrdY ' uwzglednia przesuniecie
   Select Case roz
        Case  CIRMOD                      'na okregu
            Call DrawOnCir(dwg, x, y)
        Case LINMOD                        ' na linii
            Call DrawOnLin(dwg, x, y)
        Case GRDMOD                        'siatka
            Call DrawOnGrd(dwg, x, y)
        Case SERMOD                        'siatka
            Call DrawSerieHol(dwg,x,y)        
    End Select
    DrawSymbol = bRet
End Function

Function DrawSerieHol( dwg As Object, ByVal x As Double, ByVal y As Double)
	Dim vx, vy As Double
	vx = x
	vy = y
	Do
		WriteSettings 'ZAPISZ DANE
		Call ClcRotXY (x ,y, 0)
	 	Select Case Dat.vHolTyp
            		Case ROUHOL
                  			Call DrawCir (dwg,  vx, vy)
                  			Call DrawLine(dwg, vx -1.2*Dat.vDoX/2 , vy  ,vx+1.2*Dat.vDoX/2 ,vy , 4, 14,0)  ' os symetrii
                  			Call DrawLine(dwg,vx, vy-1.2*Dat.vDoX/2 , vx,vy+1.2*Dat.vDoX/2  , 4, 14 ,0) ' os symetrii
                  				'nic nie zmieniamy bo jest ustwiony jako domyslny
            		Case OBLHOL
                  			Call DrawObl (dwg,  vx,  vy, 0)
            		Case RECHOL
                   		Call DrawRec (dwg,  vx,  vy, 0)
            		Case SQRHOL
                   		Call DrawRec (dwg,  vx,  vy, 0)
         		End Select
      Loop Until (RunDlg("") <> -1)
End Function

Function DrawOnLin(dwg As Object, ByVal  x As Double, ByVal y As Double)
   Dim i  As Integer
   Dim vx, vy As Double
      For i = 0 To Dat.vCntX - 1
         vx = x + Dat.vDrX *i
         vy = y
         Select Case Dat.vHolTyp
            Case ROUHOL
                  Call DrawCir (dwg,  vx,  vy)
                  Call DrawLine(dwg, vx -1.2*Dat.vDoX/2 , vy  ,vx+1.2*Dat.vDoX/2 ,vy , 4, 14,0)  ' os symetrii
                  Call DrawLine(dwg,vx, vy-1.2*Dat.vDoX/2 , vx,vy+1.2*Dat.vDoX/2  , 4, 14 ,0) ' os symetrii
                  'nic nie zmieniamy bo jest ustwiony jako domyslny
            Case OBLHOL
                  Call DrawObl (dwg,  vx,  vy, 0)
            Case RECHOL
                   Call DrawRec (dwg,  vx,  vy, 0)
            Case SQRHOL
                   Call DrawRec (dwg,  vx,  vy, 0)
         End Select
      Next
End Function

Function DrawOnCir(dwg As Object,ByVal  x As Double, ByVal y As Double) As Boolean
   Dim vX, vY As Double
   Dim i As Integer
   Dim bRet As Boolean 'wartosc zwracana przez funkcje. Falsz jesli przerwano lub blednie wprowadzono dane
   bRet = True ' na razie nie analizuje danych
        ' wprowadzanie danych przy pomocy InputBox
   Dim rotAgl As Double ' oblicz kat obrotu
   rotAgl = STD2PI/Dat.vCntX 'kat obrotu otworow
   Dim osAgl As Double

   Call DrawMidCir (dwg, x,  y)

   osAgl = (360 * 2 * Atn(Dat.vDoX/Dat.vDrX))/STD2PI ' kat w stopniach osi symetri obliczoney aby objal caly otwor
     For i = 0 To Dat.vCntX-1
      vx = x + Dat.vDrX/2 * Cos((i)*rotAgl)
      vy = y + Dat.vDrX/2 * Sin((i)*rotAgl)
      Select Case Dat.vHolTyp
            Case ROUHOL
                  Call DrawCir (dwg,  vx,  vy)
                  	Crr.X = X
   		Crr.Y = Y
                  Call DrawLine(dwg, vx -1.2*Dat.vDoX/2 , vy  ,vx+1.2*Dat.vDoX/2 ,vy , 4, 14 ,0) ' os symetrii
                  Call DrawLine(dwg, vx, vy-1.2*Dat.vDoX/2 , vx,vy+1.2*Dat.vDoX/2  , 4, 14,0  )' os symetrii
                  'nic nie zmieniamy bo jest ustwiony jako domyslny
            Case OBLHOL
                  Call DrawObl (dwg,  vx,  vy, Rad2Deg(i*rotAgl) - 90 )
            Case RECHOL
                   Call DrawRec (dwg,  vx,  vy, Rad2Deg(i*rotAgl) - 90 )
            Case SQRHOL
                    Call DrawRec (dwg,  vx,  vy, Rad2Deg(i*rotAgl) - 90 )
         End Select
	Crr.X = X
   	Crr.Y = Y

      Call DrawLine(dwg, vx-1.2*Dat.vDoX/2*Cos(i*rotAgl) ,vy-1.2*Dat.vDoX/2*Sin(i*rotAgl),vx+1.2*Dat.vDoX/2*Cos(i*rotAgl) ,vy+1.2*Dat.vDoX/2*Sin(i*rotAgl) , 4, 14,0)  ' os symetrii
      Call DrawArc(dwg,  x, y, Dat.vDrX/2, i*360/Dat.vCntX -osAgl ,i*360/Dat.vCntX + osAgl, 4, 14, 0) 'rysuje o rozmieszczenia
   Next
   DrawOnCir = bRet
End Function

Sub DrawMidCir(dwg As Object,ByVal  x As Double, ByVal y As Double)
 If Dat.vDs > 0 Then ' rysuj srodkowy otwor
        Call DrawArc(dwg, x, y,  Dat.vDs/2, 0, 360, 1, -1,0) 'rysuje okrag
        Call DrawLine(dwg, x -1.2*Dat.vDs/2 ,y , x+1.2*Dat.vDs/2 ,y , 4, 14 ,0) ' os symetrii
        Call DrawLine(dwg, x , y -1.2*Dat.vDs/2 ,x, y+1.2*Dat.vDs/2 , 4, 14,0)  ' os symetrii
  End If
End Sub

Private Sub DrawCir(dwg As Object, ByVal x As Double,ByVal  y As Double)
      If Dat.vThr Then ' jesli rysuje gwint
         Call DrawArc(dwg, x ,y,  Dat.vDoX/2, 170, 100, 2, -1,0) 'rysuje gwint
         Call DrawArc(dwg, x, y, 0.9* Dat.vDoX/2, 0, 360, 1, -10,0) 'rysuje okrag
      Else
         Call DrawArc (dwg, x ,y, Dat.vDoX/2, 0, 360, 1, -1,0) 'rysuje okrag
      End If
End Sub

Private Sub SetDia( ByVal sDia As String)
'funkcja sprawdza czy nie napisano M lub m co ustawia rysowanie otworu z gwintem
      If Left(sDia,1) = "M"  Or Left(sDia,1) = "m"Then ' rysuj gwint
         Dat.vThr = True ' rysuj gwint
         Dat.vDoX =  CDbl(Right(sDia, Len(sDia)-1))
      Else
         Dat.vDoX =  CDbl(sDia)
      End If
End Sub


Private Sub DrawOnGrd(dwg As Object,ByVal  x As Double, ByVal y As Double)
      'ustawiam punt wstawiania na srodek siatki jesli siatka ma 2 x  2
      Dim korX, korY As Double  'przesuniecia dla usyawienia srodka
      Dim i As Integer                      'licznik

      If Dat.vCntX = 2     And Dat.vCntY = 2 Then
         Call DrawMidCir (dwg, x,  y)
         korX = -Dat.vDrX/2
         korY =- Dat.vDrY/2
      Else
         korX = 0
         korY = 0
      End If

      For  i = 0 To Dat.vCntY - 1
         Call DrawOnLin(dwg, x+korx , y +i*Dat.vDrY+korY)
      Next
End Sub

Private Sub DrawObl(dwg As Object, ByVal x  As Double,ByVal  y As Double, ByVal dRot As Double )
  Dim vLen, vDia As Double

  Crr.X = X 'srodek fasolki
  Crr.Y = Y
  If  Dat.vDoX  < Dat.vDoY Then ' fasolka obrocona o 90 stopni
     Dim temp As Double
     vLen = Dat.vDoY
     vDia= Dat.vDoX
     dRot = dRot - 90
   Else
     vLen = Dat.vDoX
     vDia = Dat.vDoY
     'dRot = 0
  End If

  Call DrawLine (dwg, -vLen/2+vDia/2, -vDia/2, vLen/2-vDia/2, -vDia/2, 1, -1,dRot) 'Dolny bok fasolki
  Call DrawArc  (dwg, -vLen/2+vDia/2, 0, vDia/2, 90, 270, 1, -1,dRot)                'Lewy luk fasolki
  Call DrawLine (dwg, -vLen/2+vDia/2, vDia/2, vLen/2-vDia/2, vDia/2, 1, -1 ,dRot)'Gorny bok fasolki
  Call DrawArc  (dwg, vLen/2-vDia/2, 0, vDia/2 , 270, 90, 1, -1,dRot)          'Prawy luk fasolki
   'rysuj oie
  ' jesli jest to rozmieszczenie po okregu to nie rysuj jednej z osi
  If Dat.whrSet <> CIRMOD  Then
    Call DrawLine (dwg, -vLen/2-0.2*vDia ,0, vLen/2 + 0.2*vDia, 0, 4, 14, dRot)                                                ' os pozioma przedluzon o 0.2*vLen
    Call DrawLine (dwg, 0, vDia/2+0.2*vDia, 0, -vDia/2-0.2*vDia, 4, 14, dRot)             'Os srodkowa przedluzona 0 0.2*vDia
  End If

  If vLen > 4*(vDia) Then 'jesli dlugosc jest wieksza od 4 srednic rysuj osie lukow
       Call DrawLine (dwg, vDia/2+0.1*vDia, -vLen/2+vDia/2, -vDia/2-0.1*vDia,-vLen/2+vDia/2, 4, 14, dRot)           'Os pionowa lewa  przedluzon 0 0.1*vDia
       Call DrawLine (dwg, vLen/2-vDia/2, vDia/2+0.1*vDia, vLen/2-vDia/2, -vDia/2-0.1*vDia, 4, 14, dRot) 'Os pionowa prawa przedluzona o 0.1*Vdia
  End If

  End Sub

Private Sub DrawRec(dwg As Object, ByVal x As Double, ByVal y As Double, ByVal dRot As Double)
   ' funkcja rysuje prostokat
   Dim vBokA As Double
   Dim vBokB As Double

   vBokA = Dat.vDoX
   If Dat.vHolTyp = SQRHOL Then
        vBokB = vBokA
   Else
        vBokB = Dat.vDoY
   End If
   Crr.X = X
   Crr.Y = Y
   Call DrawLine( dwg,  -vBokA/2, -vBokB/2, -vBokA/2, vBokB/2, 1, -1, dRot ) 'lewy bok
   Call DrawLine( dwg, -vBokA/2,  vBokB/2, vBokA/2, vBokB/2, 1, -1, dRot) 'gorny bok
   Call DrawLine( dwg, vBokA/2, vBokB/2, vBokA/2, -vBokB/2, 1, -1, dRot) 'prawy bok
   Call DrawLine( dwg, vBokA/2, -vBokB/2, -vBokA/2, -vBokB/2, 1, -1, dRot) 'dolny bok
           'rysuj oie
   If Dat.whrSet <> CIRMOD  Then
      Call DrawLine( dwg, -vBokA/2-0.1*vBokB ,0, vBokA/2 + 0.1*vBokB , 0, 4, 14, dRot)          ' os pozioma przedluzon o 0.2*vBok
      Call DrawLine( dwg, 0,vBokB/2+0.1*vBokB, 0, -vBokB/2-0.1*vBokB, 4, 14,dRot)             'Os pionowa przedluzona o 0.2*vBok
   End If

End Sub

Private Sub DrawLine(dwg As Object , ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double, ByVal Typ As Integer, ByVal Pla As Integer, ByVal dRot As Double)
   '
    Call ClcRotXY (X1, Y1, dRot)  ' przelicz a wspolrzedne po obrocie
    Call ClcRotXY (X2,Y2, dRot)  ' przelicz a wspolrzedne po obrocie
    dwg.AddLine X1, Y1, X2, Y2, Typ, Pla
End Sub

Private Sub DrawArc(dwg As Object, ByVal X As Double, ByVal Y As Double,ByVal R As Double,ByVal A1 As Double, ByVal A2 As Double, ByVal Typ As Integer, ByVal Pla As Integer,ByVal dRot As Double)
    Call ClcRotXY(X,Y,dRot) ' przelicz a wspolrzedne srodka
    dwg.AddArc  X, Y, R , A1+dRot, A2+Drot, Typ, Pla          'Prawy luk fasolki
End Sub

Private Sub ClcRotXY(ByRef X As Double, ByRef Y As Double, ByVal dRot As Double)
  Dim cX, cY  As Double
   cX = X ' podstawianie wartosci pod zmienne
   cY = Y
   X = Crr.X + (cX) * Cos(Deg2Rad(dRot))- (cY) * Sin(Deg2Rad( dRot )) + Dat.vOrd.X
   Y = Crr.Y + (cX) * Sin(Deg2Rad(dRot)) + (cY) * Cos(Deg2Rad(dRot )) + Dat.vOrd.Y
  End Sub

Private Function Deg2Rad(ByVal dAng As Double) As Double
   Deg2Rad = dAng*STDPI/180
End Function

Private Function Rad2Deg(ByVal rAng As Double) As Double
   Rad2Deg = rAng*180/STDPI
End Function



Private Function fStrTok(ByVal sLine As String, ByVal sSep As String) As Variant
    Static sPrvStr As String 'zapamietuje czy juz analizowano poprzednio te linijke
    Static sCutStr As String 'zapamietana  linijka po wycieciu
    Dim sRetStr As String    'zwracany tekst do wystapienia sSeparatora
    Dim nNum As Integer


    If sPrvStr <> sLine Then 'jesli jes to nowa linijka ustawienie poczatkowe
        sPrvStr = sLine
        sCutStr = sLine
    End If

    If (Len(sCutStr) > 0) Then
        nNum = InStr(sCutStr, sSep)
        If (nNum > 1) Then
            sRetStr = Mid(sCutStr, 1, nNum - 1)
            sCutStr = Right(sCutStr, Len(sCutStr) - nNum)
        Else


            If sCutStr = sLine Then  ' koncz nie znaleziono zadnego sSeparatora
               sRetStr = ""
            Else                                ' w tej linijce byl juz sSeparator
               sRetStr = sCutStr ' koncz jesli juz nie wystepuje sSeparator
               sCutStr = ""                ' ale przeslij koniec linijki
            End If

        End If
    Else
        sRetStr ="" ' koncz jesli skonczyla sie juz linijka
    End If

    fStrTok = Trim(sRetStr)
    End Function


Public Function Nz(ByVal var As Variant, Optional ByVal dft As Variant) As String
    'funkcja zabezpiecza przed nulem
    If IsMissing(dft) Then dft = ""

    If IsNull(var) Then
        Nz = dft
    Else
        If IsEmpty(var) Then
            Nz = dft
        Else
        		If Len(var) > 0 Then
            		Nz = var
            	Else
            		Nz = dft
            	End If
	End If
    End If

End Function

Private Sub ReadSettings()
   Dat.vDoX    =   CDbl(GetSetting ("Otworki","Dane","vDoX",0))
   Dat.vDoy    =   CDbl(GetSetting ("Otworki","Dane","vDoY",0))
   Dat.vDrX    =   CDbl(GetSetting ("Otworki","Dane","vDrX",0))
   Dat.vDrY    =   CDbl(GetSetting ("Otworki","Dane","vDrY",0))
   Dat.vDs     =   CDbl(GetSetting ("Otworki","Dane","vDs", 0 ))
   Dat.vCntX   =   Val(GetSetting ("Otworki","Dane","vCntX",1))
   Dat.vCntY   =   Val(GetSetting ("Otworki","Dane","vCntY",0))
   Dat.vHolTyp =   Val(GetSetting ("Otworki","Dane","vHolTyp",0))  'okragly
   Dat.whrSet  =   Val(GetSetting ("Otworki","Dane","whrSet",1))
   Dat.vOrd.X  =   CDbl(GetSetting ("Otworki","Dane","vOrdX",0))
   Dat.vOrd.Y  =   CDbl(GetSetting ("Otworki","Dane","vOrdY",0))
   Dat.vThr    =   Val(GetSetting ("Otworki","Dane","vThr",False))
End Sub

Private Sub WriteSettings()
   SaveSetting "Otworki","Dane","vDoX"    ,CStr(Dat.vDoX)
   SaveSetting "Otworki","Dane","vDoY"    ,CStr(Dat.vDoy)
   SaveSetting "Otworki","Dane","vDrX"    ,CStr(Dat.vDrX)
   SaveSetting "Otworki","Dane","vDrY"    ,CStr(Dat.vDrY)
   SaveSetting "Otworki","Dane","vDs"     ,CStr(Dat.vDs)
   SaveSetting "Otworki","Dane","vCntX"   ,CStr(Dat.vCntX)
   SaveSetting "Otworki","Dane","vCntY"   ,CStr(Dat.vCntY)
   SaveSetting "Otworki","Dane","vHolTyp" ,CStr(Dat.vHolTyp)
   SaveSetting "Otworki","Dane","whrSet"  ,CStr(Dat.whrSet)
   SaveSetting "Otworki","Dane","vOrdX"   ,CStr(Dat.vOrd.X)
   SaveSetting "Otworki","Dane","vOrdY"   ,CStr(Dat.vOrd.Y)
   SaveSetting "Otworki","Dane","vThr"    ,CStr(Dat.vThr)
End Sub
