' (c) wellCAM CCS, LUBLIN
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 03.05.98  Romek Zaorski       Pierwsza wersja
'

Dim vrBok As Variant                                      'Szerokosc fasolki uzyto Variant dla prostszej obslugi InputBox
' Makro to rysuje otwor kwadratowy
Sub Main
        Dim doc As Object                               'Arkusz roboczy na ktory bedzie wstawiana fasolka
        Set doc = Application.ActiveDocument            'Ustawienie  jako arkusz roboczy arkusz z aktywnego okna
        Dim dwg As Object                               'Definowanie obiektu dwg
        Set dwg = doc.Drawing                           'Przypisanie obiektu dwg jako rysunek arkusza roboczego

	Dim idx As Long
        idx = dwg.AddObject()                           'Stwrz nowy obiekt rysunkowy i zapamietaj jego indeks
                                                        'ktory jest zwracany przez funkcje .AddObject
	                                                                                                  ' swoj indeks. Tworzac go przypisujemy mu indeks zwracany przez
	                                                                                                  ' funkcje  .AddObject
        If (idx > 0) Then                               'Jesli udalo sie stworzyc obiekt rysunkowy
                dwg.OpenObject(idx)                     'Otwrz obiekt w celu dodania grafiki. Identyfikatorem jest tu idx
                If DrawSymbol(dwg, 0,0) Then         'Jesli narysowano cos. Jest to wywolanie funkcjii DrawSymbol z parametrem obiektu dwg i punktem wstawienia
                        dwg.SetPointORD(0, 0)          'Punkt orientacyjny obiektu
                        dwg.CloseObject()                       'Zamknij obiekt
                        dwg.ExecuteString("SUW(mode=OSTOBI,p=[0,0])")   'Ustawia dynamicznie przesuwanie obiektu
                        'dwg.ExecuteString("KOP(mode=LSTCMP)")   'Kopiuje dynamicznie przesuwanie obiektu
                Else
                        dwg.CloseObject()                       'Zamknij obiekt
                End If

	End If

End Sub

'Podprogram - rysowanie fasolki
Function DrawSymbol(dwg As Object, x As Double, y As Double) As Boolean
        Dim ret As Boolean 'wartosc zwracana przez funkcje. Falsz jesli przerwano lub blednie wprowadzono dane
        ret = False
        ' wprowadzanie danych przy pomocy InputBox
        vrBok= InputBox("Podaj dlugosc boku")
        If Len(vrBoK) > 0 And IsNumeric(vrBok) Then                      'Jesli podano cos Nacisniecie ESC zwraca stringo o dlug = 0
               dwg.AddLine x-vrBok/2, y-vrBok/2, x-vrBok/2, y+vrBok/2, 1, -1 'lewy bok
               dwg.AddLine x-vrBok/2, y+vrBok/2, x+vrBok/2, y+vrBok/2, 1, -1 'gorny bok
               dwg.AddLine x+vrBok/2, y+vrBok/2, x+vrBok/2, y-vrBok/2, 1, -1 'prawy bok
               dwg.AddLine x+vrBok/2, y-vrBok/2, x-vrBok/2, y-vrBok/2, 1, -1 'dolny bok
                'rysuj oie
               dwg.AddLine x-vrBok/2-0.2*vrBok ,y, x+vrBok/2 + 0.2*vrBok, y, 4, 14          ' os pozioma przedluzon o 0.2*vBok
               dwg.AddLine x,y+vrBok/2+0.2*vrBok/2, x, y-vrBok/2-0.2*vrBok, 4, 14             'Os pionowa przedluzona o 0.2*vBok
               ret = True 'gdyz dodano obiekt
       End If
       DrawSymbol = ret
End Function
